## bcachefs-tools-1.31.2.tar.zst

=== Makefile ===
VERSION=$(shell cargo metadata --format-version 1 | jq -r '.packages[] | select(.name | test("bcachefs-tools")) | .version')

PREFIX?=/usr/local
LIBEXECDIR?=$(PREFIX)/libexec
DKMSDIR?=$(PREFIX)/src/bcachefs-$(VERSION)
PKG_CONFIG?=pkg-config
INSTALL=install
LN=ln
.DEFAULT_GOAL=all

ifeq ("$(origin V)", "command line")
  BUILD_VERBOSE = $(V)
endif
ifndef BUILD_VERBOSE
  BUILD_VERBOSE = 0
endif

ifeq ($(BUILD_VERBOSE),1)
  Q =
  CARGO_CLEAN_ARGS = --verbose
else
  Q = @
  CARGO_CLEAN_ARGS = --quiet
endif

# when cross compiling, cargo places the built binary in a different location
ifdef CARGO_BUILD_TARGET
	BUILT_BIN = target/$(CARGO_BUILD_TARGET)/release/bcachefs
else
	BUILT_BIN = target/release/bcachefs
endif

# Prevent recursive expansions of $(CFLAGS) to avoid repeatedly performing
# compile tests
CFLAGS:=$(CFLAGS)

CFLAGS+=-std=gnu11 -O2 -g -MMD -Wall -fPIC			\
	-Wno-pointer-sign					\
	-Wno-deprecated-declarations				\
	-fno-strict-aliasing					\
	-fno-delete-null-pointer-checks				\
	-I. -Ic_src -Iinclude -Iraid				\
	-D_FILE_OFFSET_BITS=64					\
	-D_GNU_SOURCE						\
	-D_LGPL_SOURCE						\
	-DRCU_MEMBARRIER					\
	-DZSTD_STATIC_LINKING_ONLY				\
	-DFUSE_USE_VERSION=35					\
	-DNO_BCACHEFS_CHARDEV					\
	-DNO_BCACHEFS_FS					\
	-DNO_BCACHEFS_SYSFS					\
	-DCONFIG_UNICODE					\
	-DVERSION_STRING='"$(VERSION)"'				\
	-D__SANE_USERSPACE_TYPES__				\
	$(EXTRA_CFLAGS)

# Intenionally not doing the above to $(LDFLAGS) because we rely on
# recursive expansion here (CFLAGS is not yet completely built by this line)
LDFLAGS+=$(CFLAGS) $(EXTRA_LDFLAGS)

ifdef CARGO_TOOLCHAIN_VERSION
  CARGO_TOOLCHAIN = +$(CARGO_TOOLCHAIN_VERSION)
endif

override CARGO_ARGS+=${CARGO_TOOLCHAIN}
CARGO=cargo $(CARGO_ARGS)
CARGO_PROFILE=release
# CARGO_PROFILE=debug

CARGO_BUILD_ARGS=--$(CARGO_PROFILE)
CARGO_BUILD=$(CARGO) build $(CARGO_BUILD_ARGS)

CARGO_CLEAN=$(CARGO) clean $(CARGO_CLEAN_ARGS)

include Makefile.compiler

CFLAGS+=$(call cc-disable-warning, unused-but-set-variable)
CFLAGS+=$(call cc-disable-warning, stringop-overflow)
CFLAGS+=$(call cc-disable-warning, zero-length-bounds)
CFLAGS+=$(call cc-disable-warning, missing-braces)
CFLAGS+=$(call cc-disable-warning, zero-length-array)
CFLAGS+=$(call cc-disable-warning, shift-overflow)
CFLAGS+=$(call cc-disable-warning, enum-conversion)
CFLAGS+=$(call cc-disable-warning, gnu-variable-sized-type-not-at-end)
export RUSTFLAGS:=$(RUSTFLAGS) -C default-linker-libraries

PKGCONFIG_LIBS="blkid uuid liburcu libsodium zlib liblz4 libzstd libudev libkeyutils"
ifdef BCACHEFS_FUSE
	PKGCONFIG_LIBS+="fuse3 >= 3.7"
	CFLAGS+=-DBCACHEFS_FUSE
	RUSTFLAGS+=--cfg feature="fuse"
endif

PKGCONFIG_CFLAGS:=$(shell $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_CFLAGS))
    $(error pkg-config error, command: $(PKG_CONFIG) --cflags $(PKGCONFIG_LIBS))
endif
PKGCONFIG_LDLIBS:=$(shell $(PKG_CONFIG) --libs   $(PKGCONFIG_LIBS))
ifeq (,$(PKGCONFIG_LDLIBS))
    $(error pkg-config error, command: $(PKG_CONFIG) --libs $(PKGCONFIG_LIBS))
endif
PKGCONFIG_UDEVDIR:=$(shell $(PKG_CONFIG) --variable=udevdir udev)
ifeq (,$(PKGCONFIG_UDEVDIR))
    $(error pkg-config error, command: $(PKG_CONFIG) --variable=udevdir udev)
endif
PKGCONFIG_UDEVRULESDIR:=$(PKGCONFIG_UDEVDIR)/rules.d

CFLAGS+=$(PKGCONFIG_CFLAGS)
LDLIBS+=$(PKGCONFIG_LDLIBS)
LDLIBS+=-lm -lpthread -lrt -lkeyutils -laio -ldl
LDLIBS+=$(EXTRA_LDLIBS)

ifeq ($(PREFIX),/usr)
	ROOT_SBINDIR?=/sbin
	INITRAMFS_DIR=$(PREFIX)/share/initramfs-tools
else
	ROOT_SBINDIR?=$(PREFIX)/sbin
	INITRAMFS_DIR=/etc/initramfs-tools
endif

.PHONY: all
all: bcachefs initramfs/hook dkms/dkms.conf

.PHONY: debug
debug: CFLAGS+=-Werror -DCONFIG_BCACHEFS_DEBUG=y -DCONFIG_VALGRIND=y
debug: bcachefs

.PHONY: TAGS tags
TAGS:
	ctags -e -R .

tags:
	ctags -R .

SRCS:=$(sort $(shell find . -type f ! -path '*/.*/*' -iname '*.c'))
DEPS:=$(SRCS:.c=.d)
-include $(DEPS)

OBJS:=$(SRCS:.c=.o)

%.o: %.c
	@echo "    [CC]     $@"
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

BCACHEFS_DEPS=libbcachefs.a
RUST_SRCS:=$(shell find src bch_bindgen/src -type f -iname '*.rs')

bcachefs: $(BCACHEFS_DEPS) $(RUST_SRCS)
	$(Q)$(CARGO_BUILD)

libbcachefs.a: $(OBJS)
	@echo "    [AR]     $@"
	$(Q)$(AR) -rc $@ $+

# If the version string differs from the last build, update the last version
ifneq ($(VERSION),$(shell cat .version 2>/dev/null))
.PHONY: .version
endif
.version:
	@echo "  [VERS]    $@"
	$(Q)echo '$(VERSION)' > $@

# Rebuild the 'version' command any time the version string changes
cmd_version.o : .version

dkms/dkms.conf: dkms/dkms.conf.in
	@echo "    [SED]    $@"
	$(Q)sed "s|@PACKAGE_VERSION@|$(VERSION)|g" dkms/dkms.conf.in > dkms/dkms.conf

initramfs/hook: initramfs/hook.in
	@echo "    [SED]    $@"
	$(Q)sed "s|@ROOT_SBINDIR@|$(ROOT_SBINDIR)|g" initramfs/hook.in > initramfs/hook

.PHONY: install
install: INITRAMFS_HOOK=$(INITRAMFS_DIR)/hooks/bcachefs
install: INITRAMFS_SCRIPT=$(INITRAMFS_DIR)/scripts/local-premount/bcachefs
install: all install_dkms
	$(INSTALL) -m0755 -D $(BUILT_BIN)  -t $(DESTDIR)$(ROOT_SBINDIR)
	$(INSTALL) -m0644 -D bcachefs.8    -t $(DESTDIR)$(PREFIX)/share/man/man8/
	$(INSTALL) -m0755 -D initramfs/script $(DESTDIR)$(INITRAMFS_SCRIPT)
	$(INSTALL) -m0755 -D initramfs/hook   $(DESTDIR)$(INITRAMFS_HOOK)
	$(INSTALL) -m0644 -D udev/64-bcachefs.rules -t $(DESTDIR)$(PKGCONFIG_UDEVRULESDIR)/
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mkfs.fuse.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/fsck.fuse.bcachefs
	$(LN) -sfr $(DESTDIR)$(ROOT_SBINDIR)/bcachefs $(DESTDIR)$(ROOT_SBINDIR)/mount.fuse.bcachefs

.PHONY: install_dkms
install_dkms: dkms/dkms.conf
	$(INSTALL) -m0644 -D dkms/Makefile		-t $(DESTDIR)$(DKMSDIR)
	$(INSTALL) -m0644 -D dkms/dkms.conf		-t $(DESTDIR)$(DKMSDIR)
	$(INSTALL) -m0644 -D libbcachefs/Makefile	-t $(DESTDIR)$(DKMSDIR)/src/fs/bcachefs
	$(INSTALL) -m0644 -D libbcachefs/*.[ch]		-t $(DESTDIR)$(DKMSDIR)/src/fs/bcachefs
	$(INSTALL) -m0644 -D libbcachefs/vendor/*.[ch]	-t $(DESTDIR)$(DKMSDIR)/src/fs/bcachefs/vendor
	sed -i "s|^#define TRACE_INCLUDE_PATH \\.\\./\\.\\./fs/bcachefs$$|#define TRACE_INCLUDE_PATH $(DKMSDIR)/src/fs/bcachefs|" \
	  $(DESTDIR)$(DKMSDIR)/src/fs/bcachefs/trace.h

.PHONY: clean
clean:
	@echo "Cleaning all"
	$(Q)$(RM) libbcachefs.a c_src/libbcachefs.a .version dkms/dkms.conf *.tar.xz $(OBJS) $(DEPS) $(DOCGENERATED)
	$(Q)$(CARGO_CLEAN)
	$(Q)$(RM) -f $(built_scripts)

.PHONY: deb
deb: all
	debuild -us -uc -nc -b -i -I

.PHONY: rpm
rpm: clean
	rpmbuild --build-in-place -bb --define "_version $(subst -,_,$(VERSION))" packaging/bcachefs-tools.spec

bcachefs-principles-of-operation.pdf: doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex
	pdflatex doc/bcachefs-principles-of-operation.tex

doc: bcachefs-principles-of-operation.pdf

.PHONY: cargo-update-msrv
cargo-update-msrv:
	cargo +nightly generate-lockfile -Zmsrv-policy
	cargo +nightly generate-lockfile --manifest-path bch_bindgen/Cargo.toml -Zmsrv-policy

.PHONY: update-bcachefs-sources
update-bcachefs-sources:
	git rm -rf --ignore-unmatch libbcachefs
	mkdir -p libbcachefs/vendor
	cp $(LINUX_DIR)/fs/bcachefs/*.[ch] libbcachefs/
	cp $(LINUX_DIR)/fs/bcachefs/vendor/*.[ch] libbcachefs/vendor/
	cp $(LINUX_DIR)/fs/bcachefs/Makefile libbcachefs/
	git add libbcachefs/*.[ch]
	git add libbcachefs/vendor/*.[ch]
	git add libbcachefs/Makefile
	git rm -f libbcachefs/mean_and_variance_test.c
	cp $(LINUX_DIR)/include/linux/xxhash.h include/linux/
	git add include/linux/xxhash.h
	cp $(LINUX_DIR)/lib/xxhash.c linux/
	git add linux/xxhash.c
	cp $(LINUX_DIR)/include/linux/list_nulls.h include/linux/
	git add include/linux/list_nulls.h
	cp $(LINUX_DIR)/include/linux/poison.h include/linux/
	git add include/linux/poison.h
	cp $(LINUX_DIR)/include/linux/generic-radix-tree.h include/linux/
	git add include/linux/generic-radix-tree.h
	cp $(LINUX_DIR)/lib/generic-radix-tree.c linux/
	git add linux/generic-radix-tree.c
	cp $(LINUX_DIR)/include/linux/kmemleak.h include/linux/
	git add include/linux/kmemleak.h
	cp $(LINUX_DIR)/lib/math/int_sqrt.c linux/
	git add linux/int_sqrt.c
	cp $(LINUX_DIR)/scripts/Makefile.compiler ./
	git add Makefile.compiler
	$(RM) libbcachefs/*.mod.c
	git -C $(LINUX_DIR) rev-parse HEAD | tee .bcachefs_revision
	git add .bcachefs_revision


.PHONY: update-commit-bcachefs-sources
update-commit-bcachefs-sources: update-bcachefs-sources
	git commit -m "Update bcachefs sources to $(shell git -C $(LINUX_DIR) show --oneline --no-patch)"

SRCTARXZ = bcachefs-tools-$(VERSION).tar.xz
SRCDIR=bcachefs-tools-$(VERSION)

.PHONY: tarball
tarball: $(SRCTARXZ)

$(SRCTARXZ) : .gitcensus
	$(Q)tar --transform "s,^,$(SRCDIR)/," -Jcf $(SRCDIR).tar.xz  \
	    `cat .gitcensus`
	@echo Wrote: $@

.PHONY: .gitcensus
.gitcensus:
	$(Q)if test -d .git; then \
	  git ls-files > .gitcensus; \
	fi

=== debian/changelog ===
bcachefs-tools (1:1.31.2) UNRELEASED; urgency=medium

  * DKMS now works on 6.16

 -- Kent Overstreet <kent.overstreet@linux.dev>  Fri, 19 Sep 2025 02:30:19 -0400

bcachefs-tools (1:1.31.1~1) unstable; urgency=medium

  * Split DKMS into separate binary package

 -- Roman Lebedev <lebedev.ri@gmail.com>  Thu, 18 Sep 2025 03:01:17 +0300

bcachefs-tools (1:1.31.1) unstable; urgency=medium

  * DKMS support

 -- Kent Overstreet <kent.overstreet@linux.dev>  Wed, 17 Sep 2025 18:31:34 -0400

bcachefs-tools (1:1.31.0) unstable; urgency=medium

  * Fix package, build against vendored deps
  * Implement apt.bcachefs.org repo

 -- Roman Lebedev <lebedev.ri@gmail.com>  Tue, 16 Sep 2025 12:50:36 +0300

bcachefs-tools (1:1.13.0-1~exp1) experimental; urgency=medium

  * QA Upload
  * New upstream release
    - Regenerate dependency patch
  * New build-dependency: librust-env-logger-dev
  * New build-dependency: librust-owo-colors-dev
  * Add missing character in previous changelog entry
    (s/tom/toml)

 -- Jonathan Carter <jcc@debian.org>  Mon, 06 Jan 2025 12:37:38 +0200

bcachefs-tools (1:1.9.4-1~exp1) experimental; urgency=medium

  * New upstream release
  * Remove build-dependency on librust-colored-2-dev (no longer needed)
  * New build-dependencies: librust-rustix-dev, rustfmt,
                            librust-memoffset-06-dev -> librust-memoffset-dev
  * Refresh build-deps patch
  * Add upstream metadata
  * Remove self from maintaners (orphaning package)

 -- Jonathan Carter <jcc@debian.org>  Sat, 20 Jul 2024 04:19:03 +0200

bcachefs-tools (1:1.9.2-1) experimental; urgency=medium

  * New upstream release
  * Fix Vcs fields in debian/control

 -- Jonathan Carter <jcc@debian.org>  Thu, 11 Jul 2024 15:01:59 +0200

bcachefs-tools (1:1.9.1-1) unstable; urgency=medium

  * New upstream release
  * New build-depency: librust-strum-dev
  * Update copyright file

 -- Jonathan Carter <jcc@debian.org>  Thu, 20 Jun 2024 17:28:12 +0200

bcachefs-tools (1:1.7.0-1) unstable; urgency=medium

  * Upload to unstable (Closes: #1066929)
  * Bump epoch
    - Ack from pochu:
      https://lists.debian.org/msgid-search/1c5f86c9-1525-4d44-996f-3d4eed1e64d6@debian.org

 -- Jonathan Carter <jcc@debian.org>  Wed, 15 May 2024 12:04:38 +0200

bcachefs-tools (24+really1.7.0-1~exp1) experimental; urgency=medium

  [ Steinar H. Gunderson ]
  * New upstream release.
    * Remove the do-not-install-mount-symlink patch.
    * Add epoch to deal with new upstream versioning scheme,
      and disable pristine-tar option in gbp.conf, since there is no
      pristine-tar branch. (Closes: #1054620)
    * revert-bindgen-changes.patch: New patch, reinstates upstream
      hack that makes bcachefs-tools work with bindgen older than 0.69.4
      (which isn't in Debian yet).
  * Build-depend on systemd-dev, since udev.pc has moved there.
  * Enable Rust parts, including mount.bcachefs. (Closes: #1060256)
    * Include the right .mk flags to get DEB_HOST_RUST_TYPE etc., and
      export that (needed for Debian's cargo wrapper).
    * Override CARGO, and set CARGO_HOME during installation.
    * Run prepare-debian in dh_auto_configure, and clean up the vendor dir
      in dh_auto_clean.
    * Remove Cargo.lock before the build, so that we can use Debian's versions
      of all Rust crates. Also remove it in dh_auto_clean, so that it does not
      take a diff.
    * revert-bindgen-changes.patch: New patch, loosen required versions
      of Rust crates
      - errno (0.2 -> >= 0.2, < 1; Debian has 0.4)
      - udev (0.7 -> >= 0.7, < 1; Debian has 0.8)
      - memoffset (0.8.0 -> 0.6; Debian has 0.6.5, so a downgrade)
      - paste (1.0.11 -> 1.0; Debian has 1.0.8, so a downgrade)
      - bindgen (0.69.4 -> 0.66; see revert-bindgen-changes.patch above)
    * Add build-dependency on all relevant Rust crates, and on python3:native
      due to use of the Cargo wrapper.
  * Build-Depend on pkgconf instead of pkg-config (Lintian warning).
  * Add debhelper tokens to postinst and postrm scripts (Lintian warning).
  * Depend on python3:any due to bcachefsck_all being a Python script
    (Lintian warning).

  [ Jonathan Carter ]
  * Upload to experimental
  * Add librust-chrono-dev, librust-getset-dev and
    librust-gag-dev to build-depends
  * Recreate dependencies patch to match new upstream source
  * Update standards version to 4.7.0
  * Update above mentioned revert-bindgen-changes.patch

 -- Jonathan Carter <jcc@debian.org>  Thu, 25 Apr 2024 13:53:55 +0200

bcachefs-tools (24+really1.3.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Jonathan Carter <jcc@debian.org>  Wed, 03 Jan 2024 17:06:16 +0200

bcachefs-tools (24+really1.3.4-2~exp1) experimental; urgency=medium

  [ Chris Hofstaedtler ]
  * Non-maintainer upload.
  * Install files into /usr instead of /. (Closes: #1059373)

  [ Jonathan Carter ]
  * Do not install bcachefs.mount symlink (Closes: #1057295)

 -- Jonathan Carter <jcc@debian.org>  Wed, 27 Dec 2023 19:22:06 +0200

bcachefs-tools (24+really1.3.4-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 21 Nov 2023 17:26:13 +0200

bcachefs-tools (24+really1.2-1) unstable; urgency=medium

  * New upstream release (Closes: #1054613)
  * Disable new rust build
    (dependencies currently unavailable in Debian, see debian/README.todo)
  * Remove unneeded override_dh_auto_clean from debian/rules
    (Closes: #1043654)

 -- Jonathan Carter <jcc@debian.org>  Thu, 28 Sep 2023 19:54:47 +0200

bcachefs-tools (24-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 29 Nov 2022 09:40:27 +0200

bcachefs-tools (23-1) unstable; urgency=medium

  * New upstream release
  * Update standards version to 4.6.1

 -- Jonathan Carter <jcc@debian.org>  Mon, 31 Oct 2022 11:45:25 +0200

bcachefs-tools (0.1+git20220216.a1e928a-1) unstable; urgency=medium

  * New upstream snapshot
  * Grab patch from Ubuntu to reduce memory on amd64 builders


=== debian/control ===
Source: bcachefs-tools
Maintainer: Roman Lebedev <lebedev.ri@gmail.com>
Section: utils
Priority: optional
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               cargo,
               dh-dkms,
               jq,
               libaio-dev,
               libblkid-dev,
               libclang-dev,
               libfuse3-dev,
               libkeyutils-dev,
               liblz4-dev,
               libscrypt-dev,
               libsodium-dev,
               libudev-dev,
               liburcu-dev (>= 0.15),
               libzstd-dev,
               pkgconf,
               python3-docutils,
               python3:native,
               rustc (>= 1.77),
               systemd-dev,
               uuid-dev,
               zlib1g-dev,
Homepage: https://bcachefs.org/
Vcs-Git: git://evilpiepirate.org/bcachefs-tools.git
Vcs-Browser: https://evilpiepirate.org/git/bcachefs-tools.git

Package: bcachefs-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3:any
Recommends: bcachefs-kernel-dkms (= ${binary:Version}),
            initramfs-tools | linux-initramfs-tool,
Breaks: bcachefs-kernel-dkms (<< ${binary:Version}),
        bcachefs-kernel-dkms (>> ${binary:Version}),
Description: bcachefs userspace tools
 Userspace tools for bcachefs, a modern copy on write, checksumming, multi
 device filesystem.
 .
 Note: The current Debian kernels do not come with bcachefs support, you
 will have to install bcachefs-kernel-dkms package or build your own kernel
 or one provided by a 3rd party that contains bcachefs support.

Package: bcachefs-kernel-dkms
Architecture: linux-any
Section: kernel
Depends: ${misc:Depends},
	 initramfs-tools | linux-initramfs-tool,
	 linux-headers-amd64 [amd64],
	 linux-headers-arm64 [arm64],
Pre-Depends: bcachefs-tools (= ${binary:Version}),
Provides: bcachefs-kernel
Description: bcachefs kernel module DKMS source
 "The COW filesystem for Linux that won't eat your data".
 .
 Bcachefs is an advanced new filesystem for Linux, with an emphasis
 on reliability and robustness and the complete set of features
 one would expect from a modern filesystem.
 .
  * Copy on write (COW) - like zfs
  * Full data and metadata checksumming, for full data integrity:
    the filesystem should always detect (and where possible,
    recover from) damage; it should never return incorrect data.
  * Multiple devices
  * Replication
  * Erasure coding (incomplete) High performance: doesn't fragment
    your writes (like ZFS), no RAID hole
  * Caching, data placement
  * Compression
  * Encryption
  * Snapshots
  * Nocow mode
  * Reflink
  * Extended attributes, ACLs, quotas
  * Petabyte scalability
  * Full online fsck, check and repair (in progress)
  * Robustness and rock solid repair. Damage and breakage are a fact of life,
    it's not a matter of if, but when. It doesn't matter what happened
    to the filesystem: bad hardware, lightning strikes, an errant dd,
    you can expect that bcachefs will repair the damage and keep going,
    usually with no user intervention required.
 .
 It's the job of the filesystem to never lose your data:
 anything that can be repaired, will be.
